#!/bin/sh

if [ $# -lt 1 ]; then echo "Usage: $0 iface";  exit 1 ; fi

CONFIG_ROOT_DIR="/data/rtl8192c"
CONFIG_DIR=$CONFIG_ROOT_DIR/$1

./script/default_setting.sh $1

SCRIPT_DIR=`cat $CONFIG_ROOT_DIR/wifi_script_dir`
BIN_DIR=`cat $CONFIG_ROOT_DIR/wifi_bin_dir`

if [ -f $BIN_DIR/iwpriv ]; then
	echo "iwpriv path is " $BIN_DIR/iwpriv
else
	echo "ERROR : Can't find iwpriv path. Path=" $BIN_DIR/iwpriv
	exit 1
fi

export SCRIPT_DIR
export BIN_DIR

# [wlan_mode] 0: AP mode 1: Client mode
echo "1" > $CONFIG_DIR/wlan_mode
# [network_type] 0: Infrastructure 1: Ad-hoc
echo "0" > $CONFIG_DIR/network_type
# [ssid] SSID which client want to join
echo "E5756_5.15" > $CONFIG_DIR/ssid

#./script/wpa-tkip.sh $1 client
./script/init.sh

#IP_ADDR=`cat $CONFIG_DIR/ip_addr`
#ifconfig $1 $IP_ADDR
